function(BUDHO_RESOURCES)
    cmake_parse_arguments(
        BUDHO_ATTACH_RESOURCES_PREFIX
        ""
        "TARGET"
        "TEMPLATES;DOCUMENTS"
        ${ARGN}
    )
    
    message(STATUS "ARGN ${ARGN}")
    message(STATUS "BUDHO_ATTACH_RESOURCES_PREFIX_TARGET ${BUDHO_ATTACH_RESOURCES_PREFIX_TARGET}")
    message(STATUS "BUDHO_ATTACH_RESOURCES_PREFIX_TEMPLATES ${BUDHO_ATTACH_RESOURCES_PREFIX_TEMPLATES}")
    message(STATUS "BUDHO_ATTACH_RESOURCES_PREFIX_DOCUMENTS ${BUDHO_ATTACH_RESOURCES_PREFIX_DOCUMENTS}")
    
    execute_process(COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/dummy.cpp)
    add_library(${BUDHO_ATTACH_RESOURCES_PREFIX_TARGET} ${CMAKE_CURRENT_BINARY_DIR}/dummy.cpp)
    
    if(DEFINED BUDHO_ATTACH_RESOURCES_PREFIX_TEMPLATES)
        set(BUDHO_TEMPLATES_TARGET_NAME "${BUDHO_ATTACH_RESOURCES_PREFIX_TARGET}-templates")    
        cmrc_add_resource_library(${BUDHO_TEMPLATES_TARGET_NAME} NAMESPACE templates
            ${BUDHO_ATTACH_RESOURCES_PREFIX_TEMPLATES}
        )
        target_link_libraries(${BUDHO_ATTACH_RESOURCES_PREFIX_TARGET} ${BUDHO_TEMPLATES_TARGET_NAME})
    endif()
    
    if(DEFINED BUDHO_ATTACH_RESOURCES_PREFIX_DOCUMENTS)
        message(STATUS "Compiling documents")
        set(BUDHO_DOCUMENTS_TARGET_NAME "${BUDHO_ATTACH_RESOURCES_PREFIX_TARGET}-documents")
        cmrc_add_resource_library(${BUDHO_DOCUMENTS_TARGET_NAME} NAMESPACE documents
            ${BUDHO_ATTACH_RESOURCES_PREFIX_DOCUMENTS}
        )
        target_link_libraries(${BUDHO_ATTACH_RESOURCES_PREFIX_TARGET} ${BUDHO_DOCUMENTS_TARGET_NAME})
    endif()
endfunction()

function(BUDHO_ATTACH)
    cmake_parse_arguments(
        BUDHO_ATTACH_PREFIX
        ""
        "TARGET;COMPONENTS"
        ""
        ${ARGN}
    )
    
    message(STATUS "ARGN ${ARGN}")
    message(STATUS "BUDHO_ATTACH_PREFIX_TARGET ${BUDHO_ATTACH_PREFIX_TARGET}")
    message(STATUS "BUDHO_ATTACH_PREFIX_COMPONENTS ${BUDHO_ATTACH_PREFIX_COMPONENTS}")
    
    set(BUDHO_ATTACH_BUNDLER_NAME "${BUDHO_ATTACH_PREFIX_TARGET}-bundler")
    set(BUDHO_ATTACH_SERVER_NAME  "${BUDHO_ATTACH_PREFIX_TARGET}")
    set(BUDHO_ATTACH_BUNDLED_NAME "${BUDHO_ATTACH_PREFIX_TARGET}-bundled")
    set(BUDHO_ATTACH_DIST_NAME    "${BUDHO_ATTACH_PREFIX_TARGET}-dist")
    
    set(BUDHO_JS_COMPONENTS "${CMAKE_CURRENT_SOURCE_DIR}/${BUDHO_ATTACH_PREFIX_COMPONENTS}")
    set(BUDHO_JS_SOURCES_BASE_DIR   "${CMAKE_CURRENT_BINARY_DIR}/sources")
    set(BUDHO_JS_SOURCES_PACKED_CPP "packed.cpp")
    set(BUDHO_JS_SOURCES_PACKED "${BUDHO_JS_SOURCES_BASE_DIR}/${BUDHO_JS_SOURCES_PACKED_CPP}")
    
    get_target_property(BUDHO_SERVER_SOURCES ${BUDHO_ATTACH_PREFIX_TARGET} SOURCES)
    get_target_property(BUDHO_SERVER_LIBS ${BUDHO_ATTACH_PREFIX_TARGET} LINK_LIBRARIES)
    add_executable(${BUDHO_ATTACH_BUNDLER_NAME} ${BUDHO_SERVER_SOURCES})
    target_link_libraries(${BUDHO_ATTACH_BUNDLER_NAME} budho ${BUDHO_SERVER_LIBS})
    target_compile_definitions(${BUDHO_ATTACH_BUNDLER_NAME} PRIVATE BUDHO_BUNDLER=1)
           
    add_custom_target(${BUDHO_ATTACH_BUNDLED_NAME} 
        COMMAND ${BUDHO_ATTACH_BUNDLER_NAME} -g --in ${BUDHO_JS_COMPONENTS} --out ${BUDHO_JS_SOURCES_BASE_DIR}
        DEPENDS ${BUDHO_ATTACH_BUNDLER_NAME} ${BUDHO_JS_COMPONENTS}
        COMMENT "Budho Bundling"
    )
    
    add_custom_command(
        COMMAND echo
        DEPENDS ${BUDHO_ATTACH_BUNDLED_NAME}
        OUTPUT  ${BUDHO_JS_SOURCES_PACKED}
        COMMENT "Generating Components"
    )
    
    add_library(${BUDHO_ATTACH_DIST_NAME} ${BUDHO_JS_SOURCES_PACKED})
    target_link_libraries(${BUDHO_ATTACH_DIST_NAME} budho)
    add_dependencies(${BUDHO_ATTACH_DIST_NAME} ${BUDHO_ATTACH_BUNDLED_NAME})
    
    target_link_libraries(${BUDHO_ATTACH_SERVER_NAME} ${BUDHO_ATTACH_DIST_NAME})
    add_dependencies(${BUDHO_ATTACH_SERVER_NAME} ${BUDHO_ATTACH_DIST_NAME})
    target_compile_definitions(${BUDHO_ATTACH_SERVER_NAME} PRIVATE BUDHO_SERVER=1)
endfunction()
